
#define ENGINE_ENABLE_FPS	' enable FPS counting code

#Include "ege.bas"			' import EGE source 

Using Elite					' we use Elite Namespace


' first we declare our starting point (the Engine.onInitialize event handler)
Declare Sub Game_onInitialize


' in module constructor we attach onInitialize event handler
Sub Game Constructor
	
	Engine.onInitialize.Attach ProcPtr(Game_onInitialize)
	
End Sub


' now we declare game screens

Dim Shared As Engine.GameScreenHandle	MainScreen


' and their event handlers:

Declare Sub MainScreen_onShow
Declare Sub MainScreen_onFrame(fElapsed As Single, eInputEvent As Engine.InputEvent, eventData As FB.EVENT) 


' now we implement those handlers

' get's called when screen is shown
Sub MainScreen_onShow
	
	Print "main screen shown"
	
End Sub

' get's called on each frame
Sub MainScreen_onFrame(fElapsed As Single, eInputEvent As Engine.InputEvent, eventData As FB.EVENT)
	
	If eInputEvent = Engine.MouseMove Then
		
		Print eventData.x, eventData.y, eventData.dx, eventData.dy
		
	EndIf
	
End Sub


' now we implement onInitialize event handler
Sub Game_onInitialize
	
	MainScreen = Engine.NewGameScreen
	
	Engine.GameScreen(MainScreen).onShow.Attach ProcPtr(MainScreen_onShow)
	Engine.GameScreen(MainScreen).onFrame.Attach ProcPtr(MainScreen_onFrame)
	
	Engine.Show MainScreen	' the game can begin!
	' - Engine.Show will also call Engine.Start if this is first screen we're Showing 
		
End Sub

' and finaly we can start the game!
Engine.Initialize 640, 480, False, FB.GFX_NO_SWITCH

End 1  ' be sure to exit :)
